from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'api_chk_emails',


class ApiChkEmails(CRUDBase):

    # 获取hr所有待处理简历
    async def get_chk_emails(self, db: AsyncIOMotorDatabase, hr_id):
        where = {
            'hr_id': hr_id,
            'is_chk': 0
        }
        return await self.find_many(db, where, {'_id': 0})

    # 插入一条全新的待处理简历
    async def insert_chk_emails(self, db: AsyncIOMotorDatabase, data):
        return await self.insert_one(db, data)

    # 更新一条待处理简历信息
    async def update_chk_emails(self, db: AsyncIOMotorDatabase, data_in: schemas.UpdateEmails):
        return await self.update_one(db, {'email_id': data_in.email_id}, {'$set': data_in.update_data})

    # 查询待处理简历信息
    async def get_emails(self, db: AsyncIOMotorDatabase, where):
        return await self.find_many(db, where, {'_id': 0})

    # 获取一条待处理简历信息
    async def get_one_email(self, db: AsyncIOMotorDatabase, email_id):
        return await self.find_one(db, {'email_id': email_id}, {'_id': 0})


api_chk_emails = ApiChkEmails('chk_emails')
