from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'department',

from utils import get_uid


class CRUDProjectNumber(CRUDBase):
    # 获取所有数据
    async def all_dep(self, db: AsyncIOMotorDatabase):
        return await self.find_many(db, {})

    # 获取对应条件数据
    async def where_dep(self, db: AsyncIOMotorDatabase, where):
        return await self.find_many(db, where,{'_id':0})

    # 修改数据
    async def update(self, db: AsyncIOMotorDatabase, up,where):
        await self.update_one(db, {'uid': where}, {'$set': up})

    # 插入数据
    async def create(self, db: AsyncIOMotorDatabase, data_in: dict):
        return await self.insert_one(db, data_in)


department = CRUDProjectNumber('department')
