from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'api_find_column',


class ApiFindColumn(CRUDBase):

    # 获取所有
    async def get_find_columns(self, db: AsyncIOMotorDatabase):
        return await self.find_many(db, {}, {'_id': 0})

    # 插入一条新数据
    async def insert_columns(self, db: AsyncIOMotorDatabase, insert_data):
        return await self.insert_one(db, insert_data)

    # 更新一条数据
    async def update_columns(self, db: AsyncIOMotorDatabase, update_data, where={}):
        return await self.update_one(db, where, {'$set': update_data})

    # 查询数据
    async def get_columns(self, db: AsyncIOMotorDatabase, where={}):
        return await self.find_many(db, where, {'_id': 0})

    # 获取一条数据
    async def get_one_column(self, db: AsyncIOMotorDatabase, where={}):
        return await self.find_one(db, where, {'_id': 0})


api_find_column = ApiFindColumn('find_column')
