from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'owner_info',


class CRUDOwnerInfo(CRUDBase):
    # 获取所有渠道信息
    async def all_owner(self, db: AsyncIOMotorDatabase):
        return await self.find_many(db, {}, {'_id': 0})

    # 获取指定字段
    async def find_owner_some(self, db: AsyncIOMotorDatabase, where={}, findlist=[]):
        findWhere = {'_id': 0}
        if findlist:
            for key in findlist:
                findWhere.update({
                    key: 1
                })
        return await self.find_many(db, where, findWhere)

    # 更新一条渠道信息
    async def update_owner(self, db: AsyncIOMotorDatabase, where, updatedata):

        await self.update_one(db, where, {'$set': updatedata})

    # 插入一条新的渠道数据
    async def insert_owner(self, db: AsyncIOMotorDatabase, insertdata):

        await self.insert_one(db, insertdata)


owner_info = CRUDOwnerInfo('owner_info')
