import time
import random
from datetime import datetime

from pydantic import BaseModel


def get_id():
    return hex(int(time.time() * 10 ** 7) + random.randint(0, 10000))[2:]


# 待处理简历模板
class InsertEmails(BaseModel):
    email_id: str  # 唯一id
    is_chk: int = 0  # 是否已处理
    hr_id: str  # hr_id
    file_url: str  # 简历华为云地址
    other_file: str  # 简历附件文件夹地址
    mode_time: datetime = datetime.now()  # 修改时间


# 查询待处理简历
class FindEmails(BaseModel):
    hr_id: str  # 简历所属hr的uid
    where: dict = {}  # 其他条件


# 更新待处理简历
class UpdateEmails(BaseModel):
    email_id: str  # 唯一id
    is_pass: int = 1  # 唯一id
    update_data: dict  # 更新的数据
